## libjna-java 3.1.0

=== native/Makefile ===
--- 
+++ 
@@ -23,34 +23,40 @@
 OS=$(shell uname | sed -e 's/\(CYGWIN\|MINGW32\).*/win32/g' \
                         -e 's/SunOS.*/solaris/g' \
                         -e 's/FreeBSD.*/freebsd/g' \
+                        -e 's/OpenBSD.*/openbsd/g' \
                         -e 's/Darwin.*/darwin/g' \
                         -e 's/Linux.*/linux/g')
 
-VERSION=3.0.4 # auto-generated by ant
-CHECKSUM=892beacd437514d23ed9b1cefeb2ead6 # auto-generated by ant
+VERSION=3.1.0 # auto-generated by ant
+CHECKSUM=816e53324203bcffe46f43e482e5c286 # auto-generated by ant
 
 JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \
               -I"$(JAVA_HOME)/include/$(OS)"
 
-LIBDIR=$(JAVA_HOME)/jre/lib/$(ARCH)
 BUILD=../build/native
 JAVAH=$(BUILD)
 INSTALLDIR=../build/$(OS)
 JNIDISPATCH_OBJS=$(BUILD)/dispatch.o $(BUILD)/callback.o $(EXTRAOBJS)
 RSRC=$(BUILD)/rsrc.o
+ifneq ($(DYNAMIC_LIBFFI),true)
 FFI_SRC=$(shell pwd)/libffi
 FFI_BUILD=$(BUILD)/libffi
-FFI_LIB=$(FFI_BUILD)/.libs/libffi_convenience.a
-FFI_CONFIG=--disable-static --with-pic=yes
+FFI_LIB=$(FFI_BUILD)/.libs/libffi$(ARSFX)
+FFI_ENV=CC="$(CC)" CFLAGS="$(CDEBUG)" CPPFLAGS="$(CDEFINES)"
+FFI_CONFIG=--enable-static --disable-shared --with-pic=yes
+endif
 LIBRARY=$(BUILD)/$(LIBPFX)jnidispatch$(JNISFX)
 TESTLIB=$(BUILD)/$(LIBPFX)testlib$(LIBSFX)
+TESTLIB2=$(BUILD)/$(LIBPFX)testlib2$(LIBSFX)
 
 # Reasonable defaults based on GCC
 LIBPFX=lib
 LIBSFX=.so
+ARSFX=.a
 JNISFX=$(LIBSFX)
 CC=gcc
 LD=gcc
+LIBS=
 # Default to Sun recommendations for JNI compilation
 #COPT=-O2 -fomit-frame-pointer
 COPT=-fno-omit-frame-pointer -fno-strict-aliasing 
@@ -58,14 +64,21 @@
 ifeq ($(DEBUG),true)
 CDEBUG=-g
 endif
+CFLAGS_EXTRA=
 COUT=-o $@
 CINCLUDES=$(JAVA_INCLUDES) -I"$(JAVAH)" -I$(FFI_BUILD)/include
 CDEFINES=-D_REENTRANT
 PCFLAGS=-W -Wall -Wno-unused -Wno-parentheses
-CFLAGS=$(PCFLAGS) $(COPT) $(CDEBUG) $(CDEFINES) $(CINCLUDES) \
+CFLAGS=$(PCFLAGS) $(CFLAGS_EXTRA) $(COPT) $(CDEBUG) $(CDEFINES) $(CINCLUDES) \
        -DVERSION='"$(VERSION)"' -DCHECKSUM='"$(CHECKSUM)"'
+LDFLAGS=-o $@ -shared 
+ifeq ($(DYNAMIC_LIBFFI),true)
+CFLAGS += $(shell pkg-config --cflags libffi 2>/dev/null || echo)
+LIBS += $(shell pkg-config --libs libffi 2>/dev/null || echo -lffi)
+else
 # -static-libgcc avoids gcc library incompatibilities across linux systems
-LDFLAGS=-o $@ -shared -static-libgcc
+LDFLAGS += -static-libgcc
+endif
 # Avoid bug in X11-based 1.5/1.6 VMs; dynamically load instead of linking
 # See http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=6539705
 #LIBS=-L"$(LIBDIR)" -ljawt 
@@ -73,47 +86,59 @@
 # end defaults
 
 ifeq ($(OS),win32)
-# Uncomment this line to use MSVC (doesn't yet work with libffi)
-#CC=cl
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
 CDEFINES=-DHAVE_PROTECTION
-
-ifeq ($(CC),cl)
-LD=link
-COPT=-O1 -Op
-ifeq ($(DEBUG),true)
-COPT=-Od
-DBG=d
-CDEBUG=-D_DEBUG -GZ -Zi
-endif
-COUT=-Fo$@
-PCFLAGS=-nologo -MD$(DBG) -W3 -WX -GX -YX -Fd$(@D)/$* -Fp$(@D)/$*
-CASM=-FAs
-
-LDFLAGS=/pdb:$(subst .dll,,$@).pdb /implib:$(subst .dll,,$@).lib /debug /machine:i386 /pdbtype:sept /dll /nologo /opt:REF /incremental:no /out:$@ 
-LIBDIR=/libpath:"$(JAVA_HOME)/lib" 
-#LIBS=$(LIBDIR) jawt.lib
+WINDRES=windres
+EXTRAOBJS=$(RSRC)
 STRIP=@echo
-else
+LIBPFX=
+LIBSFX=.dll
+
+ifeq ($(CC),gcc)
 CC += -mno-cygwin
 LD += -mno-cygwin -Wl,--add-stdcall-alias
-LIBDIR="$(JAVA_HOME)/lib"
-#LIBS=$(LIBDIR)/jawt.lib
-endif
-
-LIBPFX=
-LIBSFX=.dll
-EXTRAOBJS=$(RSRC)
+endif
+
+ifeq ($(ARCH),amd64)
+
+WINDRES=/usr/local/mingw64-cross/bin/x86_64-pc-mingw32-windres
+
+# Uncomment to enable MINGW64 cross compiler
+# Last build attempt has too many runtime problems (alloca broken) (080831)
+#MINGW = x86_64-pc-mingw32-gcc
+ifneq ($(MINGW),)
+CC = $(MINGW) -m64 -mno-cygwin
+LD = $(CC)
+LDFLAGS=-o $@ -shared
+LIBS= -lmingwex -lkernel32 -lmsvcrt
+FFI_CONFIG += --host=x86_64-pc-mingw32
+else
+# MSVC (wrapper scripts)
+CC=$(FFI_SRC)/../cc.sh -m64
+LD=$(FFI_SRC)/../ld.sh -m64
+ARSFX=.lib
+FFI_CONFIG += --host=x86_64-pc-mingw32 && rm -f include/ffitarget.h && cp $(FFI_SRC)/include/*.h $(FFI_SRC)/src/x86/ffitarget.h include
+FFI_ENV += LD="$(LD)" CPP=cpp
+endif
+endif
 endif
 
 ifeq ($(OS),linux)
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
 PCFLAGS+=-fPIC
 CDEFINES+=-DHAVE_PROTECTION
-LDFLAGS+=-Wl,-soname,$@ 
+LDFLAGS+=-Wl,-soname,$@
 endif
 
 ifeq ($(OS),freebsd)
+ARCH=$(shell uname -m | sed 's/i.86/i386/g')
+PCFLAGS+=-fPIC
+CINCLUDES+=-I/usr/X11R6/include
+LDFLAGS=-o $@ -shared 
+CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT
+endif
+
+ifeq ($(OS),openbsd)
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
 PCFLAGS+=-fPIC
 CINCLUDES+=-I/usr/X11R6/include
@@ -137,9 +162,11 @@
 endif
 
 # Enable 64-bit builds if the arch demands it
+ifeq ($(CC),gcc)
 ifeq ($(ARCH),amd64)
   CC += -m64
   LD += -m64
+endif
 endif
 
 ifeq ($(OS),darwin)
@@ -156,8 +183,8 @@
 ISYSROOT=-isysroot $(SDKROOT)
 ARCHFLAGS=-arch ppc -arch i386
 ifneq ($(findstring 10.5,$(SDKROOT)),)
-ALT_ARCHS+=x86_64 #ppc64
-ARCHFLAGS+=-arch x86_64 #-arch ppc64
+ALT_ARCHS+=x86_64 
+ARCHFLAGS+=-arch x86_64
 endif
 endif
 PCFLAGS+=$(ISYSROOT) -x objective-c
@@ -187,27 +214,37 @@
 	$(CC) $(CFLAGS) -c $< $(COUT)
 endif
 
-all: $(LIBRARY) $(TESTLIB)
+all: $(LIBRARY) $(TESTLIB) $(TESTLIB2)
 
 install:
 	mkdir $(INSTALLDIR)
 	cp $(LIBRARY) $(INSTALLDIR)
 
 $(RSRC): $(BUILD)/jnidispatch.rc
-	windres -i $< -o $@
+	$(WINDRES) -i $< -o $@ \
+          || (echo > $@.c && $(CC) $(CFLAGS) -c $@.c $(COUT))
 
 $(LIBRARY): $(JNIDISPATCH_OBJS) $(FFI_LIB) 
 	$(LD) $(LDFLAGS) $(JNIDISPATCH_OBJS) $(FFI_LIB) $(LIBS)
 
 $(TESTLIB): $(BUILD)/testlib.o 
-	$(LD) $(LDFLAGS) $< $(TESTDEF)
-
+	$(LD) $(LDFLAGS) $<
+
+ifeq ($(ARSFX),.lib)
+TESTDEP=$(TESTLIB:.dll=.lib)
+else
+TESTDEP=$(TESTLIB)
+endif
+$(TESTLIB2): $(BUILD)/testlib2.o 
+	$(LD) $(LDFLAGS) $< $(TESTDEP)
+
+ifneq ($(DYNAMIC_LIBFFI),true)
 $(FFI_LIB):
 	@mkdir -p $(FFI_BUILD)
 	@if [ ! -f $(FFI_BUILD)/Makefile ]; then \
 	  echo "Configuring libffi ($(ARCH))"; \
 	  (cd $(FFI_BUILD) \
-	    && CC="$(CC)" CFLAGS="$(CDEBUG)" CPPFLAGS="$(CDEFINES)" $(FFI_SRC)/configure $(FFI_CONFIG)); \
+	    && $(FFI_ENV) $(FFI_SRC)/configure $(FFI_CONFIG)); \
 	fi
 	$(MAKE) -C $(FFI_BUILD)
 ifneq ($(SDKROOT),)
@@ -225,6 +262,7 @@
 	/usr/bin/libtool -static -o $@.tmp $(FFI_BUILD)/.libs/${@F} $(BUILD)/libffi.*/.libs/${@F}
 	mv $@.tmp $@
 endif
+endif
 
 clean:
 	$(RM) -rf $(BUILD)
