## libjna-java 3.2.4

=== debian/changelog ===
libjna-java (3.2.4-2ubuntu2) natty; urgency=low

  * Fix incorrect generation of PowerPC multi-arch paths (LP: #737603).

 -- James Page <james.page@canonical.com>  Mon, 28 Mar 2011 09:27:48 +0100

libjna-java (3.2.4-2ubuntu1) natty; urgency=low

  * Fix native library search to be multi-arch compatible (LP: #737603):
    - debian/patches/07-multiarch-support.patch : figure out 
      platform and form search path accordingly. 

 -- James Page <james.page@canonical.com>  Tue, 22 Mar 2011 08:57:17 +0000

libjna-java (3.2.4-2) unstable; urgency=low

  * make libjna-java buildable on GNU/kFreeBSD
  * debian/control: set Build-Depends to default-jdk | openjdk-6-jdk
  * set JAVA_HOME to /usr/lib/jvm/default-java
  * add debian/patches/05-support-gnu-kfreebsd.patch to support
    GNU/kFreeBSD architectures
  * debian/rules: add -Djni.md5="" to ant call
  * import debian/patches/50-remove-gjdoc-inexistent-options.dpatch as
    debian/patches/06-remove-gjdoc-inexistent-options.patch

 -- Jan Dittberner <jandd@debian.org>  Wed, 26 May 2010 00:14:07 +0200

libjna-java (3.2.4-1) unstable; urgency=low

  [ Ludovic Claude ]
  * Team upload.
  * New upstream release
  * Added myself as uploader
  * Add Maven metadata
  * debian/control:
     - add dependency on maven-repo-helper

  [ Jan Dittberner ]
  * refresh patches

 -- Jan Dittberner <jandd@debian.org>  Wed, 21 Apr 2010 16:36:37 +0200

libjna-java (3.2.3-2) unstable; urgency=low

  * Team upload.
  * refresh patches
  * add debian/patches/04-load-native-code-from-fs.patch to try to load
    native library from /usr/lib/jni if system property
    jna.boot.library.path is not set (Closes: #576879)
  * debian/control:
    - set debhelper dependency to >= 7.0.50~
    - update Standards-Version to 3.8.4 (no changes needed)
    - add Vcs-Git and Vcs-Browser fields
  * switch to source format 3.0 (quilt)
    - add debian/source/format
    - remove quilt dependency from debian/control
    - remove patch rules from debian/rules
    - modify clean target to work with unpatched sources too
  * parse version from changelog in debian/rules
  * add myself to Uploaders
  * switch to dh7 rules in debian/rules

 -- Jan Dittberner <jandd@debian.org>  Thu, 08 Apr 2010 14:51:06 +0200

libjna-java (3.2.3-1) unstable; urgency=low

  * New upstream release.
  * Fixed debian/repack-source.sh to correctly use mktemp.
  * Make libjna-java Depends on *-headless packages.
  * Moved package under pkg-java control.
  * Added debian/README.source to describe quilt.
  * Added myself as Uploader.

 -- Michael Koch <konqueror@gmx.de>  Mon, 02 Nov 2009 14:14:51 +0100

libjna-java (3.1.0-5) unstable; urgency=low

  * Removing vcs fields.
  * Removing README.source.
  * Orphaning package.

 -- Daniel Baumann <daniel@debian.org>  Thu, 27 Aug 2009 08:47:56 +0200

libjna-java (3.1.0-4) unstable; urgency=low

  * Rediffing nbproject.patch (Closes: #538624).
  * Updating to standards version 3.8.3.
  * Adding maintainer homepage field to control.
  * Marking maintainer homepage field to be also included in binary
    packages and changelog.
  * Adding README.source.

 -- Daniel Baumann <daniel@debian.org>  Tue, 25 Aug 2009 11:41:51 +0200

libjna-java (3.1.0-3) unstable; urgency=low

  * Updating maintainer field.
  * Updating vcs fields.
  * Updating, sorting and wrapping depends.

 -- Daniel Baumann <daniel@debian.org>  Sat, 15 Aug 2009 09:40:19 +0200

libjna-java (3.1.0-2) unstable; urgency=low

  * Removing watch file.
  * Flipping maintainer and uploaders field.
  * Upgrading package to standards version 3.8.2.
  * Updating package sections.

 -- Daniel Baumann <daniel@debian.org>  Sun, 26 Jul 2009 15:57:25 +0200

libjna-java (3.1.0-1) unstable; urgency=low

  * Updating standards to 3.8.1.
  * Using correct rfc-2822 date formats in changelog.
  * Merging upstream version 3.1.0.
  * Updating version number in rules.
  * Updating year in copyright file.
  * Updating rules file to current state of the art.

 -- Daniel Baumann <daniel@debian.org>  Tue, 09 Jun 2009 11:36:24 +0200

libjna-java (3.0.9-1) unstable; urgency=low

  * Initial release (Closes: #480074).

 -- Daniel Baumann <daniel@debian.org>  Fri, 02 Jan 2009 09:41:00 -0500
