=== debian/rules ===
#!/usr/bin/make -f

export JAVA_HOME=/usr/lib/jvm/default-java

VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')

override_dh_auto_clean:
	if [ -f nbproject/profiler-build-impl.xml ]; then \
		ant -f build.xml clean; \
	fi
	rm -f build.number

	dh_clean

override_dh_auto_build:
	ant -f build.xml -Dcflags_extra.native="" -Ddynlink.native=true -Dnomixedjar.native=true -Djni.md5="" jar
	ant -f build.xml javadoc

override_dh_auto_install:
	mh_installpoms -plibjna-java
	mh_installjar -plibjna-java -l --usj-name=jna pom.xml build/jna.jar

override_dh_makeshlibs:
	# don't call dh_makeshlibs

binary: binary-arch binary-indep

%:
	dh $@
