## libjna-java 3.2.7

=== native/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Makefile for JNA native bits
-# Copyright (c) 2007 Timothy Wall All Rights Reserved
+# Copyright (c) 2007-2010 Timothy Wall All Rights Reserved
 #
 # You may need to run 'ant javah' at the root before performing a build from 
 # this directory.
@@ -27,8 +27,8 @@
                         -e 's/Darwin.*/darwin/g' \
                         -e 's/Linux.*/linux/g')
 
-VERSION=3.1.0 # auto-generated by ant
-CHECKSUM=816e53324203bcffe46f43e482e5c286 # auto-generated by ant
+JNA_JNI_VERSION=3.2.2 # auto-generated by ant
+CHECKSUM=c870290c36c8d3fdf85db7c782febc3f # auto-generated by ant
 
 JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \
               -I"$(JAVA_HOME)/include/$(OS)"
@@ -42,7 +42,7 @@
 FFI_SRC=$(shell pwd)/libffi
 FFI_BUILD=$(BUILD)/libffi
 FFI_LIB=$(FFI_BUILD)/.libs/libffi$(ARSFX)
-FFI_ENV=CC="$(CC)" CFLAGS="$(CDEBUG)" CPPFLAGS="$(CDEFINES)"
+FFI_ENV=CC="$(CC)" CFLAGS="$(COPT) $(CDEBUG)" CPPFLAGS="$(CDEFINES)"
 FFI_CONFIG=--enable-static --disable-shared --with-pic=yes
 endif
 LIBRARY=$(BUILD)/$(LIBPFX)jnidispatch$(JNISFX)
@@ -58,8 +58,7 @@
 LD=gcc
 LIBS=
 # Default to Sun recommendations for JNI compilation
-#COPT=-O2 -fomit-frame-pointer
-COPT=-fno-omit-frame-pointer -fno-strict-aliasing 
+COPT=-O2 -fno-omit-frame-pointer -fno-strict-aliasing 
 CASM=-S
 ifeq ($(DEBUG),true)
 CDEBUG=-g
@@ -70,7 +69,7 @@
 CDEFINES=-D_REENTRANT
 PCFLAGS=-W -Wall -Wno-unused -Wno-parentheses
 CFLAGS=$(PCFLAGS) $(CFLAGS_EXTRA) $(COPT) $(CDEBUG) $(CDEFINES) $(CINCLUDES) \
-       -DVERSION='"$(VERSION)"' -DCHECKSUM='"$(CHECKSUM)"'
+       -DJNA_JNI_VERSION='"$(JNA_JNI_VERSION)"' -DCHECKSUM='"$(CHECKSUM)"'
 LDFLAGS=-o $@ -shared 
 ifeq ($(DYNAMIC_LIBFFI),true)
 CFLAGS += $(shell pkg-config --cflags libffi 2>/dev/null || echo)
@@ -87,7 +86,8 @@
 
 ifeq ($(OS),win32)
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
-CDEFINES=-DHAVE_PROTECTION
+CDEFINES=-DHAVE_PROTECTION -DPSAPI_VERSION=1
+LIBS=-lpsapi
 WINDRES=windres
 EXTRAOBJS=$(RSRC)
 STRIP=@echo
@@ -104,18 +104,20 @@
 WINDRES=/usr/local/mingw64-cross/bin/x86_64-pc-mingw32-windres
 
 # Uncomment to enable MINGW64 cross compiler
-# Last build attempt has too many runtime problems (alloca broken) (080831)
+# Should build properly as of 090601, but lacks SEH, so MSVC build is preferred
 #MINGW = x86_64-pc-mingw32-gcc
 ifneq ($(MINGW),)
 CC = $(MINGW) -m64 -mno-cygwin
 LD = $(CC)
 LDFLAGS=-o $@ -shared
-LIBS= -lmingwex -lkernel32 -lmsvcrt
+LIBS= -lmingwex -lpsapi -lkernel32 -lmsvcrt 
 FFI_CONFIG += --host=x86_64-pc-mingw32
 else
 # MSVC (wrapper scripts)
 CC=$(FFI_SRC)/../cc.sh -m64
 LD=$(FFI_SRC)/../ld.sh -m64
+COPT=
+LIBS=psapi.lib
 ARSFX=.lib
 FFI_CONFIG += --host=x86_64-pc-mingw32 && rm -f include/ffitarget.h && cp $(FFI_SRC)/include/*.h $(FFI_SRC)/src/x86/ffitarget.h include
 FFI_ENV += LD="$(LD)" CPP=cpp
@@ -190,8 +192,8 @@
 PCFLAGS+=$(ISYSROOT) -x objective-c
 CDEFINES+=-DTARGET_RT_MAC_CFM=0 -DFFI_MMAP_EXEC_WRIT
 LDFLAGS=$(ARCHFLAGS) -dynamiclib -o $@ -framework JavaVM \
-  -compatibility_version $(shell echo ${VERSION}|sed 's/^\([0-9][0-9]*\).*/\1/g') \
-  -current_version $(VERSION) \
+  -compatibility_version $(shell echo ${JNA_JNI_VERSION}|sed 's/^\([0-9][0-9]*\).*/\1/g') \
+  -current_version $(JNA_JNI_VERSION) \
   -mmacosx-version-min=10.3 \
   -install_name ${@F} \
   $(SYSLIBROOT)
@@ -268,6 +270,6 @@
 	$(RM) -rf $(BUILD) 
 
 version:
-	@echo version=$(VERSION)
+	@echo version=$(JNA_JNI_VERSION)
 
 #EOF
