=== debian/changelog ===
libjna-java (3.2.7-4) unstable; urgency=low

  * Remove optional build time dependency on openjdk-6-jdk (depend on
    default-jdk) to fix Debcheck warning.
  * Install jna-platform.jar with javahelper instead of mavenhelper
    (Closes: #629081).

 -- Andrew Ross <ubuntu@rossfamily.co.uk>  Fri, 03 Jun 2011 18:13:57 +0100

libjna-java (3.2.7-3) experimental; urgency=low

  * Seach multiarch paths for libraries (Closes: #620122)

 -- Andrew Ross <ubuntu@rossfamily.co.uk>  Wed, 25 May 2011 21:19:02 +0100

libjna-java (3.2.7-2) unstable; urgency=low

  * Build and install platform.jar too.
  * Bump Standards-Version to 3.9.2.
  * Drop dependency on jre.
  * Update debian/copyright to cover platform code.
  * Add myself to uploaders.

 -- Andrew Ross <ubuntu@rossfamily.co.uk>  Sun, 22 May 2011 21:19:01 +0100

libjna-java (3.2.7-1) unstable; urgency=low

  * New upstream release (Closes: #602564)
  * refresh patches
  * switch debian/watch to new kenai URL
  * change SVN URL in debian/repack-source.sh
  * fix debian/repack-source.sh to use the directory given to uscan via
    -destdir
  * add mh_clean to clean target in debian/rules
  * bump Standards-Version to 3.9.1
  * bump maven-repo-helper dependency to (>= 1.5~)
  * don't compress example java files

 -- Jan Dittberner <jandd@debian.org>  Sun, 20 Feb 2011 15:18:39 +0100
