=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: libjna-java
 Section: java
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
-Uploaders: Michael Koch <konqueror@gmx.de>, Jan Dittberner <jandd@debian.org>, Ludovic Claude <ludovic.claude@laposte.net>
-Build-Depends: debhelper (>= 7.0.50~), default-jdk | openjdk-6-jdk, ant,
- ant-optional, libx11-dev, libxt-dev, libffi-dev, pkg-config, maven-repo-helper
-Standards-Version: 3.8.4
+Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
+Uploaders: Michael Koch <konqueror@gmx.de>, Jan Dittberner <jandd@debian.org>, 
+ Ludovic Claude <ludovic.claude@laposte.net>, Andrew Ross <ubuntu@rossfamily.co.uk>
+Build-Depends: debhelper (>= 7.0.50~), default-jdk, ant,
+ ant-optional, libx11-dev, libxt-dev, libffi-dev, pkg-config,
+ maven-repo-helper (>= 1.5~), javahelper (>=0.32~)
+Standards-Version: 3.9.2
 Homepage: http://jna.dev.java.net/
 Vcs-Git: git://git.debian.org/pkg-java/libjna-java.git
 Vcs-Browser: http://git.debian.org/?p=pkg-java/libjna-java.git;a=summary
 
 Package: libjna-java
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, default-jre-headless | java2-runtime-headless
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: libjna-java-doc
 Description: Dynamic access of native libraries from Java without JNI
  JNA provides Java programs easy access to native shared libraries without
