=== debian/rules ===
--- 
+++ 
@@ -9,21 +9,27 @@
 		ant -f build.xml clean; \
 	fi
 	rm -f build.number
-
+	rm -rf build doc
+	rm -rf contrib/platform/build
+	mh_clean
 	dh_clean
 
 override_dh_auto_build:
-	ant -f build.xml -Dcflags_extra.native="" -Ddynlink.native=true -Dnomixedjar.native=true -Djni.md5="" jar
+	ant -f build.xml -Dcflags_extra.native="" -Ddynlink.native=true -Dnomixedjar.native=true -Djni.md5="" jar contrib-jars
 	ant -f build.xml javadoc
 
+# install. using platform.jar is a silly idea in /usr/share/java/ as it's bound to collide
 override_dh_auto_install:
-	mh_installpoms -plibjna-java
 	mh_installjar -plibjna-java -l --usj-name=jna pom.xml build/jna.jar
+	jh_installlibs -plibjna-java build/jna-platform.jar
 
 override_dh_makeshlibs:
 	# don't call dh_makeshlibs
 
+override_dh_compress:
+	dh_compress -X.java
+
 binary: binary-arch binary-indep
 
 %:
-	dh $@
+	dh $@ --with maven-repo-helper
