=== debian/watch ===
version=3

https://svn.java.net/svn/jna~svn/tags/ ([\d\.]+\d)/ debian debian/repack-source.sh
