=== debian/changelog ===
libjna-java (4.1.0-1) unstable; urgency=low

  * Team upload

  [ Andrew Ross ]
  * New upstream release (Closes: #733488)
  * Refreshed the patches (up to version 3.4.1)
  * Link javadoc to default-jdk API
  * Remove Michael Koch <konqueror@gmx.de> from uploaders (Closes: #654084).
  * Use hardening-wrapper to correct lintian warnings.
  * Update d/watch for new upstream location

  [ Emmanuel Bourg ]
  * Refreshed the patches (up to version 4.1.0)
  * Removed 08-multiarch-support.patch (merged upstream since JNA 3.5.0)
  * Removed 02-builddir.patch (merged upstream since 4.0.0)
  * Removed 05-support-gnu-kfreebsd.patch (merged upstream since 4.0.0)
  * Added a default implementation of Structure.getFieldOrder() to preserve
    the compatibility with JNA < 3.5.0
  * Moved libjnidispatch.so into its own new arch any libjna-jni package
  * Install libjnidispatch.so in a multiarch path
  * Install the Maven artifacts for the platform jar (Closes: #743732)
  * Moved platform.jar to its own libjna-platform-java package
  * Added a repack script to clean the upstream tarball
  * Install the upstream changelog
  * debian/control:
    - Use canonical URLs for the Vcs-* fields
    - Standards-Version updated to 3.9.6 (no changes)
  * Switch to debhelper level 9
  * debian/copyright:
    - Updated to the Copyright Format 1.0
    - Fixed the short name of the license applied to the debian/* files
    - JNA is now dual licensed under the LGPL-2.1+ or the Apache-2.0 license

 -- Emmanuel Bourg <ebourg@apache.org>  Thu, 16 Oct 2014 00:23:15 +0200
