=== debian/control ===
--- 
+++ 
@@ -2,19 +2,29 @@
 Section: java
 Priority: optional
 Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
-Uploaders: Michael Koch <konqueror@gmx.de>, Jan Dittberner <jandd@debian.org>, 
- Ludovic Claude <ludovic.claude@laposte.net>, Andrew Ross <ubuntu@rossfamily.co.uk>
-Build-Depends: debhelper (>= 7.0.50~), default-jdk, ant,
- ant-optional, libx11-dev, libxt-dev, libffi-dev, pkg-config,
- maven-repo-helper (>= 1.5~), javahelper (>=0.32~)
-Standards-Version: 3.9.2
-Homepage: http://jna.dev.java.net/
-Vcs-Git: git://git.debian.org/pkg-java/libjna-java.git
-Vcs-Browser: http://git.debian.org/?p=pkg-java/libjna-java.git;a=summary
+Uploaders: Jan Dittberner <jandd@debian.org>,
+           Ludovic Claude <ludovic.claude@laposte.net>,
+           Andrew Ross <ubuntu@rossfamily.co.uk>
+Build-Depends: ant,
+               ant-optional,
+               debhelper (>= 9),
+               default-jdk,
+               default-jdk-doc,
+               hardening-wrapper,
+               javahelper (>=0.32~),
+               libffi-dev,
+               libx11-dev,
+               libxt-dev,
+               maven-repo-helper (>= 1.5~),
+               pkg-config
+Standards-Version: 3.9.6
+Vcs-Git: git://anonscm.debian.org/pkg-java/libjna-java.git
+Vcs-Browser: http://anonscm.debian.org/cgit/pkg-java/libjna-java.git
+Homepage: https://github.com/twall/jna
 
 Package: libjna-java
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Architecture: all
+Depends: libjna-jni, ${misc:Depends}
 Suggests: libjna-java-doc
 Description: Dynamic access of native libraries from Java without JNI
  JNA provides Java programs easy access to native shared libraries without
@@ -32,6 +42,31 @@
  native platform features without incurring the high overhead of configuring and
  building JNI code for multiple platforms.
 
+Package: libjna-jni
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: Dynamic access of native libraries from Java without JNI (native libs)
+ JNA provides Java programs easy access to native shared libraries without
+ writing anything but Java code - no JNI or native code is required. This
+ functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
+ Access is dynamic at runtime without code generation.
+ .
+ This package contains the native libraries for libjna-java
+
+Package: libjna-platform-java
+Architecture: all
+Depends: libjna-java, ${misc:Depends}
+Replaces: libjna-java (<< 3.4.2)
+Breaks: libjna-java (<< 3.4.2)
+Description: Dynamic access of native libraries from Java without JNI (platform extension)
+ JNA provides Java programs easy access to native shared libraries without
+ writing anything but Java code - no JNI or native code is required. This
+ functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
+ Access is dynamic at runtime without code generation.
+ .
+ This package contains the platform library with many native functions already
+ mapped as well as a set of utility interfaces that simplify native access.
+
 Package: libjna-java-doc
 Section: doc
 Architecture: all
