## libjna-java 4.2.0

=== debian/changelog ===
libjna-java (4.2.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Refreshed the patches

 -- Emmanuel Bourg <ebourg@apache.org>  Sat, 03 Oct 2015 00:46:21 +0200
