=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,13 @@
 	dh $@
 
 override_dh_auto_clean:
-	ant -f build.xml -Dmaven-release=true clean
+	#ant -f build.xml -Dmaven-release=true clean
+	find -name build -type d | xargs -r rm -Rf
 	rm -f build.number
 	rm -rf build doc
 	rm -rf contrib/platform/build
 	rm -rf contrib/platform/dist
+	rm -Rf contrib/ntservice/dist
 	rm -f dist/*
 	mh_clean
 	dh_clean
