## libjna-java 4.2.1

=== debian/changelog ===
libjna-java (4.2.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
  * Improved the reproducibility:
    - Set the locale and remove the timestamps when generating the javadoc

 -- Emmanuel Bourg <ebourg@apache.org>  Tue, 03 Nov 2015 23:27:46 +0100
